﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Drawing;
using System.Globalization;
using System.Reflection;
using System.Collections.ObjectModel;

public class CustomServerLayerOverlay : ServerLayerOverlay
{
    public CustomServerLayerOverlay(string id)
        : base(id)
    { }

    protected override void DrawCore(GeoCanvas canvas, object nativeImage, RectangleShape canvasExtent, GeographyUnit mapUnit)
    {
        Collection<SimpleCandidate> labeledFeaturesInLayers = new Collection<SimpleCandidate>();
        foreach (Layer layer in Layers)
        {
            canvas.BeginDrawing(nativeImage, canvasExtent, mapUnit);
            lock (layer)
            {
                layer.Open();
                layer.Draw(canvas, labeledFeaturesInLayers);
            }
            canvas.EndDrawing();
        }
    }
}

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            EcwRasterLayer ecwRasterLayer_1 = new EcwRasterLayer(MapPath("~/App_Data/q3605sw.ecw"));
            EcwRasterLayer ecwRasterLayer_2 = new EcwRasterLayer(MapPath("~/App_Data/q3505nw.ecw"));
            EcwRasterLayer ecwRasterLayer_3 = new EcwRasterLayer(MapPath("~/App_Data/q3606se.ecw"));

            EcwRasterLayer ecwRasterLayer_4 = new EcwRasterLayer(MapPath("~/App_Data/q3605sw.ecw"));
            EcwRasterLayer ecwRasterLayer_5 = new EcwRasterLayer(MapPath("~/App_Data/q3505nw.ecw"));
            EcwRasterLayer ecwRasterLayer_6 = new EcwRasterLayer(MapPath("~/App_Data/q3606se.ecw"));

            // Native Server 1
            BackgroundLayer backgroundLayer = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromArgb(255, 156, 187, 216)));

            ServerLayerOverlay layerOverlay = new CustomServerLayerOverlay("CanaveralMap1Server");
            layerOverlay.Layers.Add(ecwRasterLayer_1);
            layerOverlay.ServerCache = new ServerCache(Request.PhysicalApplicationPath + "\\ThinkGeoCache1");
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay);

            ServerLayerOverlay layerOverlay1 = new CustomServerLayerOverlay("CanaveralMap2Server");
            layerOverlay1.Layers.Add(ecwRasterLayer_2);
            layerOverlay1.ServerCache = new ServerCache(Request.PhysicalApplicationPath + "\\ThinkGeoCache2");
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay1);

            ServerLayerOverlay layerOverlay2 = new CustomServerLayerOverlay("CanaveralMap3Server");
            layerOverlay2.Layers.Add(ecwRasterLayer_3);
            layerOverlay2.ServerCache = new ServerCache(Request.PhysicalApplicationPath + "\\ThinkGeoCache3");
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay2);
        }
    }
}
